<template>
  <div class="v-notification">
    <transition-group
      name="v-transition-animate"
      class="messages_list"
    >
      <div
        class="v-notification__content"
        v-for="message in messages"
        :key="message.id"
        :class="message.icon"
      >
        <div class="content__text">
          <img v-if="message.icon === 'alert'" src="../assets/images/icons/alert.svg" alt="">
          <img v-if="message.icon === 'warning'" src="../assets/images/icons/warning.svg" alt="">
          <img v-if="message.icon === 'check'" src="../assets/images/icons/check-alert.svg" alt="">
          <div>
            <p>{{ message.title }}</p>
            <p>{{ message.subtitle }}</p>
          </div>
        </div>
        <div class="content__buttons">
          <button v-if="rightButton.length">{{rightButton}}</button>
          <button v-if="leftButton.length">{{leftButton}}</button>
        </div>
      </div>
    </transition-group>
  </div>
</template>

<script>
export default {
  name: 'v-notification',
  props: {
    messages: {
      type: Array,
      default: () => {
        return {}
      }
    },
    rightButton: {
      type: String,
      default: ''
    },
    leftButton: {
      type: String,
      default: ''
    },
    timeout: {
      type: Number,
      default: 3000
    }
  },
  data () {
    return {}
  },
  methods: {
    hideNotification () {
      const vm = this
      if (this.messages.length) {
        setTimeout(function () {
          vm.messages.splice(vm.messages.length - 1, 1)
        }, vm.timeout)
      }
    }
  },
  watch: {
    messages () {
      this.hideNotification()
    }
  },
  mounted () {
    this.hideNotification()
  }
}
</script>

<style lang="scss">
.v-notification{
  position: fixed;
  bottom: 95px;
  left: 3.5%;
  right: 3.5%;
  width: 93%;
  z-index: 110000;
  display: flex;
  flex-direction: column-reverse;
}
.messages_list {
  display: flex;
  flex-direction: column;
}
.v-notification__content {
  padding: 10px 16px;
  color: white;
  display: flex;
  justify-content: space-between;
  align-items: center;
  height: 62px;
  margin-bottom: 16px;
  border-radius: 12px;
}
.content__text {
  display: flex;
  align-items: center;
  img {
    margin-right: 8px;
  }
  div {
    font-weight: 400;
    :first-child {
      font-size: 16px;
      line-height: 20px;
    }
    :last-child {
      font-size: 13px;
      line-height: 16px;
    }
  }
}
.v-notification__content.check{
  background: #2B7FE2;
}
.v-notification__content.warning {
  background: #FF4949;
}
.v-notification__content.alert {
  background: #2B7FE2;
}
.v-transition-animate-enter {
  transform: translateX(120px);
  opacity: 0;
}
.v-transition-animate-enter-active {
  transition: all .6s ease;
}
.v-transition-animate-enter-to {
  opacity: 1;
}
.v-transition-animate-leave {
  height: 62px;
  opacity: 1;
}
.v-transition-animate-leave-active {
  transition: transform .6s ease, opacity .6s, height .6s .2s;
}
.v-transition-animate-leave-to {
  height: 0;
  transform: translateX(120px);
  opacity: 0;
}
.v-transition-animate-move {
  transition: transform .6s;
}
</style>
